Imports Microsoft.VisualBasic.ControlChars
Imports System.Drawing.Imaging
Imports System.io
Imports System.Collections.Generic
Imports System.Environment

Public Class frmMain
    Private _ShotDir As String
    Private _ShotFile As String = "ScreenShot"
    Private _ShotTemplate As String

    Private Sub frmMain_Load(ByVal sender As Object, _
        ByVal e As EventArgs) Handles MyBase.Load

        ' Alle mglichen ImageFormate in die Combobox eintragen
        Dim Formats As ImageFormat() = New ImageFormat() { _
           ImageFormat.Bmp, ImageFormat.Emf, ImageFormat.Exif, _
           ImageFormat.Gif, ImageFormat.Icon, ImageFormat.Jpeg, _
           ImageFormat.Png, ImageFormat.Tiff, ImageFormat.Wmf}
        Me.cmbSaveAs.ComboBox.DataSource = Formats
        ' Voreinstellung
        Me.cmbSaveAs.SelectedItem = ImageFormat.Png

        ' Gegebenenfalls Unterordner in "Eigene Bilder" anlegen
        _ShotDir = Path.Combine(GetFolderPath(SpecialFolder.MyPictures), _
            "ScreenShots")
        If Not Directory.Exists(_ShotDir) Then _
            Directory.CreateDirectory(_ShotDir)
        _ShotTemplate = Path.Combine(_ShotDir, _ShotFile)
    End Sub

    Private Sub btSave_Click(ByVal sender As Object, _
        ByVal e As EventArgs) Handles btSave.Click

        ' Klick-Feedback geben
        My.Computer.Audio.PlaySystemSound(Media.SystemSounds.Asterisk)

        ' Erforderlichen Nummern-Anhang fr die Datei herausfinden
        Dim SearchPattern As String = _
            String.Concat(_ShotFile, "??.", cmbSaveAs.SelectedItem)
        Dim Files As String() = Directory.GetFiles(_ShotDir, SearchPattern)
        Dim Numb As Integer = 0
        If Files.Length > 0 Then
            Array.Sort(Files)
            Numb = Integer.Parse(Files(Files.Length - 1).Substring( _
                _ShotTemplate.Length, 2)) + 1
        End If

        'Foto-Position bestimmen
        Dim Rct As Rectangle
        With Me.PhotoPanel
            ' Umrechnung auf Bildschirmkoordinaten
            Rct = .RectangleToScreen(.ClientRectangle)
        End With

        ' Knipsen und speichern
        Using Bmp As Bitmap = New Bitmap(Rct.Width, Rct.Height), _
                g As Graphics = Graphics.FromImage(Bmp)

            g.CopyFromScreen(Rct.Location, Point.Empty, Rct.Size)
            Dim Format As ImageFormat = DirectCast(cmbSaveAs.SelectedItem,  _
                ImageFormat)
            Bmp.Save(String.Concat(_ShotTemplate, Numb.ToString("00"), ".", _
                Format), Format)
        End Using
    End Sub

    Private Sub btOpenShotFolder_Click(ByVal sender As Object, _
        ByVal e As EventArgs) Handles btOpenShotFolder.Click

        ' "Eigene Bilder\ScreenShots" im Explorer ffnen
        Process.Start(_ShotDir)
    End Sub
End Class
